	list      p=16f628A           ;  
	#include <p16F628A.inc>       ;    PIC16F628A

	errorlevel  -302              ;       (  )

	__CONFIG   _CP_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC		; 


;*********  
w_temp        EQU     0x71        ;     (W)  
status_temp   EQU     0x72        ;     STATUS

	CBLOCK	0x20
		digit1
		digit2
		digit3
		digit4
		blink1
		blink2
		blink3
		blink4
		tics, blink_tics
		blink_flags
		hours, mins, secs
		bin, hund, t_a_o
		tmp_out
		k_tmr
		z_tmr
		z_tmr_set
		keys
		key_flags
	ENDC



;**********************************************************************
	ORG     0x000             ;   (PIC   )
	movlw	0x07
	movwf	CMCON			  ;    
	goto    Init              ;  
	

	ORG     0x004             ;   
	movwf   w_temp            ;   W
	movf	STATUS,w          ; 
	movwf	status_temp       ;   STATUS
	clrf	STATUS			  ;   STATUS,   ,     
	bcf		PIR1,TMR2IF		  ;    

ind_start
	movlw	b'11110000'		  ;   
	andwf	PORTA,f
	comf	INDF,W			  ;       (..    )
	movwf	tmp_out			  ;    

	movlw	d'4'			  ;    4
	addwf	FSR,f
	movf	INDF,W			  ;   
	btfsc	blink_flags,0	  ;        ( )
	iorwf	tmp_out,f		  ;      .1 ( )
	movlw	d'4'			  ;   4  .
	subwf	FSR,f

	movf	tmp_out,W		  ;   
	movwf	PORTB			  ;  

	movlw	0x20			
	subwf	FSR,W			  ;     H'20' (..    0  3, .. 4 )
	call	ind_cnv			  ;     ()  
	iorwf	PORTA,f			  ;      (,  )

	incf	FSR,f			  ;  
	movlw	0x20+d'4'		  ;   4    
	subwf	FSR,W		
	btfss	STATUS,Z		
	goto	clock			  ; ,     
	movlw	0x20			  ; ,   FSR    -   1- 
	movwf	FSR
	goto	clock

ind_cnv	
	andlw	b'00000011'		  ;  
	addwf	PCL,f
	retlw	b'00000010'	;0	  ;1-  RA1
	retlw	b'00000100'	;1	  ;2-  RA2
	retlw	b'00000001'	;2	  ;3-  RA0
	retlw	b'00001000'	;3	  ;4-  RA3


clock	
	incf	tics,f			  ; 
	movlw	d'250'		
	subwf	tics,W			  ;     250
	btfss	STATUS,Z		  ;
	goto	skip_clock		  ;   
	clrf	tics			  ;    250   

	incf	secs,f			  ;  
	movlw	d'60'			  
	subwf	secs,W			  ;        60
	btfss	STATUS,Z		  
	goto	skip_clock		  ; ,     
	clrf	secs			  ;  ,   
	
	incf	mins,f			  ;  60  -  
	movlw	d'60'			
	subwf	mins,W			  ;    60 
	btfss	STATUS,Z
	goto	skip_clock
	clrf	mins

	incf	hours,f			  ;   
;	movlw	d'24'
	movlw	d'13'
	subwf	hours,W			  ;    24 .
	btfss	STATUS,Z
	goto	skip_clock	
;	clrf	hours			  ;  ,   , , ,   .. :-)
	movlw	d'1'
	movwf	hours

skip_clock
	incf	blink_tics,f   		;        .
	movlw	d'125'				;  ( 250,  . 125) 
	subwf	blink_tics,W		
	btfss	STATUS,Z
	goto	skip_blink
	clrf	blink_tics

	movlw	b'00000001'			;   (     )
	xorwf	blink_flags,f	

skip_blink
go_home
	movf    status_temp,w     ;   STATUS
	movwf	STATUS            ; 
	swapf   w_temp,f
	swapf   w_temp,w          ;   W
	retfie                    ;   


;*********************************************************************************************  
convert
	andlw	0x0F			;   (      )
	addwf	PCL,f			;      PCL.      
			 ;BAEFhCDG		;            .
	retlw	b'11110110'		;0
	retlw	b'10000100'		;1
	retlw	b'11100011'		;2
	retlw	b'11000111'		;3
	retlw	b'10010101'		;4
	retlw	b'01010111'		;5
	retlw	b'01110111'		;6
	retlw	b'11010100'		;7
	retlw	b'11110111'		;8
	retlw	b'11010111'		;9
	retlw	b'00000000'		;A
	retlw	b'00000000'		;B
	retlw	b'00000000'		;C
	retlw	b'00000000'		;D
	retlw	b'00000000'		;E
	retlw	b'00000000'		;F

;*********************************************************************************************  
main
	call	show_clock		;    
	call	key_test		;    
	clrwdt					;  
	goto	main			;    

;******************************************************************************************************  
key_test
	incf	k_tmr,f			;  
	movlw	0x7F
	subwf	k_tmr,W			;      H'7F'
	btfsc	STATUS,Z	
	goto	read_1			;  1-  
	movlw	0xFF
	subwf	k_tmr,W			;   FF
	btfsc	STATUS,Z
	goto	read_2			;  2-  (      )
	return					;      .

read_1						;1- 
	movf	PORTA,W			;    
	andlw	b'00110000'		;  
	movwf	keys			;    keys
	return			

read_2						;2- 
	movf	PORTA,W			;      
	andlw	b'00110000'		;   
	xorwf	keys,W			;    
	btfss	STATUS,Z		;   -       ( -   )
	return					
	
	incf	z_tmr,f			;    
	movf	z_tmr_set,W
	subwf	z_tmr,W		
	btfss	STATUS,C		;        
	return
	clrf	z_tmr

	movlw	0x06			;   z_tmr    (  )
	movwf	z_tmr_set

	
	btfss	keys,4			;   1
	goto	inc_hour
	btfss	keys,5			;   2
	goto	inc_min

	movlw	0x01		;    ,  Z_TMR    (    )
	movwf	z_tmr_set
	clrf	key_flags	;      (..         )
 
	return

inc_hour
	movf	key_flags,W		;     , ..     
	btfss	STATUS,Z
	goto	skip_hour_fast	; ,      ( )
	movlw	0x0D
	movwf	z_tmr_set		;   ,     


skip_hour_fast
	bsf		key_flags,0		;   
	clrf	secs			;  
	incf	hours,f			;  
;	movlw	d'24'			;   
	movlw	d'13'
	subwf	hours,W
;	btfsc	STATUS,Z
	btfss	STATUS,Z
	return
;	clrf	hours
	movlw	d'1'
	movwf	hours
	return
	

inc_min						
	movf	key_flags,W		;   ,      
	btfss	STATUS,Z		
	goto	skip_min_fast	;    

	movlw	0x0D			;    
	movwf	z_tmr_set

skip_min_fast
	bsf		key_flags,0		;   
	clrf	secs			;  
	incf	mins,f			;  
	movlw	d'60'			;  
	subwf	mins,W
	btfsc	STATUS,Z	;    .   ( )  1  
	clrf	mins		;      ,     
	return			; 59   00,   61, ..    .
				;       .
				;    .   ,    
				; ,    :-)
	
;***************************************************************************************************  
show_clock
		 
	clrf	blink1			; 1-     ,  
		     ;BAEFhCDG
	movlw	b'00001000'		; 2-    ,     h
	movwf	blink2		
	clrf	blink3			;3  4    ,  
	clrf	blink4

	movf	hours,W		;  
	movwf	bin			;  
	call	b_bcd		;  - 

	swapf	t_a_o,W		;   ( )     .
	andlw	0x0F		;(     ,       )
	btfsc	STATUS,Z	;     -    
	movlw	0x0A		;  0A       . ..   
	call	convert		;        ()           
	movwf	digit1		;    

	movf	t_a_o,W		;    
	andlw	0x0F
	call	convert
		     ;BAEFhCDG
	iorlw	b'00001000'	;   ()
	movwf	digit2


	movf	mins,W		;    
	movwf	bin
	call	b_bcd

	swapf	t_a_o,W		;   ,   -  
	andlw	0x0F		;    .
	call	convert
	movwf	digit3		;    3  4      .

	movf	t_a_o,W		; ,    
	andlw	0x0F
	call	convert
	movwf	digit4		
	return				;    .      .

;***********************************************************     -
b_bcd
	clrf	hund				;    ,     
	swapf	bin,W
	addwf	bin,W				;  ,   BIN  
	andlw	b'00001111'			; - .
	skpndc					; 0x0F -  15. 
	addlw	0x16				;bin = 0x0F
	skpndc					;hund () = 0x00
	addlw	0x06				;t_a_o (  ) = 0x15
	addlw	0x06				;..  t_a_o       
	skpdc					;   .
	addlw	-0x06
	btfsc	bin,4
	addlw	0x16-1+0x6
	skpdc
	addlw	-0x06
	btfsc	bin,5
	addlw	0x30
	btfsc	bin,6
	addlw	0x60
	btfsc	bin,7
	addlw	0x20
	addlw	0x60
	rlf		hund,f
	btfss 	hund,0
	addlw 	-0x60
	movwf 	t_a_o
	btfsc 	bin,7
	incf	hund,f
	return
	
;***************************************************************************************************** 
Init
	clrwdt					;  
	movlw	0xFF			;     (, ..      1 -  )
	movwf	PORTB			;       Z ,      
	clrf	PORTA			;    

	bsf		STATUS,RP0		;  1- 
	movlw	b'11110000'		; RA0-RA3   RA4-R5   (RA6 RA7  )
	movwf	TRISA
	movlw	b'00000000'		;     
	movwf	TRISB
	movlw	b'10000000'		; .   .       
	movwf	OPTION_REG
	movlw	d'249'			;  TMR2 - 249 (      4 )
	movwf	PR2
	bsf		PIE1,TMR2IE		;   TMR2
	bcf		STATUS,RP0		;   

	movlw	b'00000111'		;  TMR2 1:16   
	movwf	T2CON

	movlw	0x20			;     020 (1-  )
	movwf	FSR

	clrf	digit1			;    .
	clrf	digit2
	clrf	digit3
	clrf	digit4
	clrf	blink1
	clrf	blink2
	clrf	blink3
	clrf	blink4
	clrf	tics
	clrf	blink_tics
	clrf	blink_flags
	clrf	hours
	clrf	mins
	clrf	secs
	clrf	k_tmr
	clrf	z_tmr
	clrf	z_tmr_set
	clrf	keys
	clrf	key_flags

	clrwdt				;  
	
	bsf		INTCON,PEIE		;     (   2)
	bsf		INTCON,GIE		;    - ,    
	goto	main			;     MAIN   



	END                       ;  -  

